/*
 * LicManStore.java
 *
 * Created on March 5, 2006, 5:22 PM
 */

package com.runstate.licman;

import com.runstate.licman.entities.Application;
import com.runstate.licman.entities.User;
import com.runstate.licman.entities.Version;
import java.util.List;
import java.util.Properties;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.NoResultException;
import javax.persistence.Persistence;
import javax.persistence.PersistenceContextType;
import javax.persistence.Query;

/**
 *
 * @author dj
 */
public class LicManStore {
    
    private EntityManagerFactory emf;
    private EntityManager em;
    
    private static LicManStore myInstance;
    
    
    public static LicManStore getStore() {
        if(myInstance==null) {
            myInstance=new LicManStore();
        }
        
        return myInstance;
    }
    
    private LicManStore() {
        emf=Persistence.createEntityManagerFactory("appman", new Properties());
        em=emf.createEntityManager(PersistenceContextType.EXTENDED);
    }
    
    public void saveApplication(Application a) {
        EntityTransaction tx=em.getTransaction();
        tx.begin();
        em.persist(a);
        tx.commit();
    }
    
    public void updateApplication(Application a) {
        EntityTransaction tx=em.getTransaction();
        tx.begin();
        em.merge(a);
        tx.commit();
    }
    
    
    void deleteApplication(Application app) {
        EntityTransaction tx=em.getTransaction();
        tx.begin();
        em.remove(app);
        tx.commit();
    }
    
    void saveUser(User user) {
        EntityTransaction tx=em.getTransaction();
        tx.begin();
        em.persist(user);
        tx.commit();
    }
    
    User getUser(String s) {
        return (User)em.find(User.class,s);
    }
    
    Version getVersion(Application app,String name) {
        try {
            Query q=em.createQuery("select ver from Version as ver where application=:app and versionname=:name");
            q.setParameter("app",app);
            q.setParameter("name",name);
            return (Version)q.getSingleResult();
        } catch (NoResultException nre) {
            return null; }
    }
    
    Application getApplication(String s) {
        try {
            Query q=em.createQuery("select app from Application as app where applicationname=:appname");
            q.setParameter("appname",s);
            return (Application)q.getSingleResult();
        } catch (NoResultException nre) {
            return null; }
    }
    
    List<Application> getApplications() {
        return (List<Application>)em.createQuery("select app from Application as app order by applicationname asc").getResultList();
    }
    
    List<User> getAllUsers() {
        return (List<User>)em.createQuery("select user from User as user order by username asc").getResultList();
    }

    void refresh(Object o) {
        em.refresh(o);
    }
}
