/*
 * LicManUI.java
 *
 * Created on March 7, 2006, 9:54 AM
 */

package com.runstate.licman;

import com.runstate.licman.entities.Application;
import com.runstate.licman.entities.Licence;
import com.runstate.licman.entities.User;
import com.runstate.licman.entities.Version;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Arrays;
import java.util.List;
import javax.swing.JList;
import javax.swing.JOptionPane;

/**
 *
 * @author  dj
 */
public class LicManUI extends javax.swing.JFrame {
    
    /**
     * Creates new form LicManUI
     */
    public LicManUI(Controller controller) {
        this.controller=controller;
        initComponents();
        applicationList.setCellRenderer(new SimpleCellRenderer());
        applicationList.setModel(controller.getApplicationListModel());
        versionList.setCellRenderer(new SimpleCellRenderer());
        versionList.setModel(controller.getVersionListModel());
        licenceList.setCellRenderer(new SimpleCellRenderer());
        licenceList.setModel(controller.getLicenceListModel());
        userList.setCellRenderer(new SimpleCellRenderer());
        userList.setModel(controller.getUserListModel());
        allUserList.setCellRenderer(new SimpleCellRenderer());
        allUserList.setModel(controller.getAllUserListModel());
        allUserList.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
                JList list = (JList)evt.getSource();
                if (evt.getClickCount() == 2) {
                    allUserListDoubleClicked(allUserList.locationToIndex(evt.getPoint()));
                }
            }
        });
    }
    
    private void allUserListDoubleClicked(int index)
    {
        User u=(User)allUserList.getModel().getElementAt(index);
        if(u==null) return;
        controller.showUserReport(u);
       
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        applicationList = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        versionList = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        licenceList = new javax.swing.JList();
        addAppButton = new javax.swing.JButton();
        deleteAppButton = new javax.swing.JButton();
        addVersionButton = new javax.swing.JButton();
        deleteVersionButton = new javax.swing.JButton();
        addLicenceButton = new javax.swing.JButton();
        deleteLicenceButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        userList = new javax.swing.JList();
        addUserToLicenceButton = new javax.swing.JButton();
        removeUserFromLicenceButton = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        addUserAllButton = new javax.swing.JButton();
        removeUserAllButton = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane5 = new javax.swing.JScrollPane();
        allUserList = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        applicationList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        applicationList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        applicationList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                applicationSelectionChange(evt);
            }
        });

        jScrollPane1.setViewportView(applicationList);

        versionList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        versionList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                versionListValueChanged(evt);
            }
        });

        jScrollPane2.setViewportView(versionList);

        licenceList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        licenceList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                licenceListValueChanged(evt);
            }
        });

        jScrollPane3.setViewportView(licenceList);

        addAppButton.setText("+");
        addAppButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAppButtonActionPerformed(evt);
            }
        });

        deleteAppButton.setText("-");
        deleteAppButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteAppButtonActionPerformed(evt);
            }
        });

        addVersionButton.setText("+");
        addVersionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addVersionButtonActionPerformed(evt);
            }
        });

        deleteVersionButton.setText("-");
        deleteVersionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteVersionButtonActionPerformed(evt);
            }
        });

        addLicenceButton.setText("+");
        addLicenceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addLicenceButtonActionPerformed(evt);
            }
        });

        deleteLicenceButton.setText("-");
        deleteLicenceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteLicenceButtonActionPerformed(evt);
            }
        });

        jLabel1.setText("Applications");

        jLabel2.setText("Versions");

        jLabel3.setText("Licences");

        userList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane4.setViewportView(userList);

        addUserToLicenceButton.setText("<");
        addUserToLicenceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addUserToLicenceButtonActionPerformed(evt);
            }
        });

        removeUserFromLicenceButton.setText(">");
        removeUserFromLicenceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeUserFromLicenceButtonActionPerformed(evt);
            }
        });

        jLabel4.setText("Users");

        addUserAllButton.setText("+");
        addUserAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addUserAllButtonActionPerformed(evt);
            }
        });

        removeUserAllButton.setText("-");

        jLabel5.setText("All Users");

        allUserList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane5.setViewportView(allUserList);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 102, Short.MAX_VALUE)
                    .add(jLabel1)
                    .add(layout.createSequentialGroup()
                        .add(addAppButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 44, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(deleteAppButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 41, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 102, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(addVersionButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(deleteVersionButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 39, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jLabel2))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel3)
                    .add(layout.createSequentialGroup()
                        .add(addLicenceButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 39, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(deleteLicenceButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 102, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel4)
                    .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(addUserToLicenceButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 0, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(removeUserFromLicenceButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 44, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel5)
                    .add(layout.createSequentialGroup()
                        .add(addUserAllButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(removeUserAllButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 102, Short.MAX_VALUE))
                .addContainerGap())
        );

        layout.linkSize(new java.awt.Component[] {addAppButton, addLicenceButton, addUserAllButton, addUserToLicenceButton, addVersionButton, deleteAppButton, deleteLicenceButton, deleteVersionButton, removeUserAllButton, removeUserFromLicenceButton}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel1)
                            .add(jLabel2)
                            .add(jLabel3)
                            .add(jLabel4))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(addUserToLicenceButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 108, Short.MAX_VALUE)
                                .add(removeUserFromLicenceButton))
                            .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE)
                            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE)
                            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(addAppButton)
                            .add(addVersionButton)
                            .add(deleteVersionButton)
                            .add(addLicenceButton)
                            .add(deleteLicenceButton)
                            .add(deleteAppButton)))
                    .add(layout.createSequentialGroup()
                        .add(jLabel5)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(removeUserAllButton)
                            .add(addUserAllButton))))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void deleteLicenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteLicenceButtonActionPerformed
        Licence l=(Licence)licenceList.getSelectedValue();
        controller.deleteLicence(l);
    }//GEN-LAST:event_deleteLicenceButtonActionPerformed
    
    private void licenceListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_licenceListValueChanged
        Licence l=(Licence)licenceList.getSelectedValue();
        controller.selectedLicence(l);
    }//GEN-LAST:event_licenceListValueChanged
    
    private void removeUserFromLicenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeUserFromLicenceButtonActionPerformed
        List u=Arrays.asList(userList.getSelectedValues());
        try {
            controller.removeUsersFromLicence(u);
        } catch (UpdateException ex) {
            JOptionPane.showMessageDialog(this,ex,"Error",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_removeUserFromLicenceButtonActionPerformed
    
    private void addUserToLicenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addUserToLicenceButtonActionPerformed
        List u=Arrays.asList(allUserList.getSelectedValues());
        try {
            controller.addUsersToLicence(u);
        } catch (UpdateException ex) {
            JOptionPane.showMessageDialog(this,ex,"Error",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_addUserToLicenceButtonActionPerformed
    
    private void deleteVersionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteVersionButtonActionPerformed
        Version v=(Version)versionList.getSelectedValue();
        controller.deleteVersion(v);
    }//GEN-LAST:event_deleteVersionButtonActionPerformed
    
    private void addUserAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addUserAllButtonActionPerformed
        String s=(String)JOptionPane.showInputDialog(this,"Enter the new user name","User",JOptionPane.PLAIN_MESSAGE);
        if(s==null) return;
        try {
            controller.addUser(s);
        } catch (UpdateException ex) {
            JOptionPane.showMessageDialog(this,ex,"Error",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_addUserAllButtonActionPerformed
    
    private void addLicenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addLicenceButtonActionPerformed
        String s=(String)JOptionPane.showInputDialog(this,"Enter the new license key","License",JOptionPane.PLAIN_MESSAGE);
        if(s==null) return;
        controller.addLicence(s);
    }//GEN-LAST:event_addLicenceButtonActionPerformed
    
    private void versionListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_versionListValueChanged
        Version version=(Version)versionList.getSelectedValue();
        controller.selectedVersion(version);
    }//GEN-LAST:event_versionListValueChanged
    
    private void deleteAppButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAppButtonActionPerformed
        Application app=(Application)applicationList.getSelectedValue();
        if(app==null) return;
        controller.deleteApplication(app);
    }//GEN-LAST:event_deleteAppButtonActionPerformed
    
    private void addVersionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addVersionButtonActionPerformed
        String s=(String)JOptionPane.showInputDialog(this,"Enter the new version name","Version",JOptionPane.PLAIN_MESSAGE);
        if(s==null) return;
        try {
            controller.addVersion(s);
        } catch (UpdateException ex) {
            JOptionPane.showMessageDialog(this,ex,"Error",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_addVersionButtonActionPerformed
    
    private void addAppButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAppButtonActionPerformed
        String s=(String)JOptionPane.showInputDialog(this,"Enter the new application name","Application",JOptionPane.PLAIN_MESSAGE);
        if(s==null) return;
        try {
            controller.addApplication(s);
        } catch (UpdateException ex) {
            JOptionPane.showMessageDialog(this,ex,"Error",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_addAppButtonActionPerformed
    
    private void applicationSelectionChange(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_applicationSelectionChange
        Application app=(Application)applicationList.getSelectedValue();
        controller.selectedApplication(app);
    }//GEN-LAST:event_applicationSelectionChange
    
    void setVersionPaneEnabled(boolean enabled) {
        versionList.setEnabled(enabled);
        addVersionButton.setEnabled(enabled);
        deleteVersionButton.setEnabled(enabled);
    }
    
    void setLicencePaneEnabled(boolean enabled) {
        licenceList.setEnabled(enabled);
        addLicenceButton.setEnabled(enabled);
        deleteLicenceButton.setEnabled(enabled);
    }
    
    void setUserPaneEnabled(boolean enabled) {
        userList.setEnabled(enabled);
        addUserToLicenceButton.setEnabled(enabled);
        removeUserFromLicenceButton.setEnabled(enabled);
    }

    void setSelectedApplication(Application app) {
        applicationList.setSelectedValue(app,true);
    }
    
    void setSelectedVersion(Version ver)
    {
        versionList.setSelectedValue(ver,true);
    }
    
    void setSelectedLicence(Licence lic)
    {
        licenceList.setSelectedValue(lic,true);
    }
    
    private Controller controller;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addAppButton;
    private javax.swing.JButton addLicenceButton;
    private javax.swing.JButton addUserAllButton;
    private javax.swing.JButton addUserToLicenceButton;
    private javax.swing.JButton addVersionButton;
    private javax.swing.JList allUserList;
    private javax.swing.JList applicationList;
    private javax.swing.JButton deleteAppButton;
    private javax.swing.JButton deleteLicenceButton;
    private javax.swing.JButton deleteVersionButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JList licenceList;
    private javax.swing.JButton removeUserAllButton;
    private javax.swing.JButton removeUserFromLicenceButton;
    private javax.swing.JList userList;
    private javax.swing.JList versionList;
    // End of variables declaration//GEN-END:variables
    
}
